<?php
// $Author: noah $
// $Revision: 0.0 $
// $Date: 2004/11/05 00:17:16 $
//
// This is the user management index page for admin users (root).
// This presents an interface to add, delete, and edit users.
//

require_once ("login.php");
bounce_not_root ();
require_once ("config.php");

switch ($_REQUEST['command'])
{
	case 'add':
	add ();
	return;
	break;

	case 'del':
	del ();
	return;
	break;

	case 'areyousure':
	areyousure ();
	return;
	break;

	case 'edit':
	edit();
	return;
	break;

	case 'update':
	update();
	return;
	break;
}

//////////////////////////////////////////////////////////////////////////////
// This is displayed when there is no command given to this page.
//////////////////////////////////////////////////////////////////////////////
session_start();
$self = $_SERVER['PHP_SELF'];
$_SESSION['return_page']=$self;
require_once ("header.php");
$return_page = "main_root.php";
require_once ("return.php");
?>
<h1>User Administration</h1>
<hr noshade size="1">
<h2>Create User</h2>
<form name="user_add" method="post">
 <input type="hidden" name="return_page" value="<?php echo $return_page; ?>">
 <input type="hidden" name="command" value="add">
 <table cellSpacing="0" cellPadding="3" border="0">
   <tr>
    <td width="120">Username</td>
    <td><input name="username" type="text"></td>
   </tr>
   <tr>
    <td width="120">Password</td>
    <td><input type="password" name="password"></td>
   </tr>
   <tr>
    <td width="120">Password Confirm</td>
    <td><input type="password" name="password_confirm"></td>
   </tr>
   <tr>
    <td width="120">Full Name</td>
    <td><input name="fullname" type="text"></td>
   </tr>
   <tr>
    <td></td>
    <td align="right"><input type="submit" name="submit" value="add"></td>
   </tr>
 </table>
</form>

<hr noshade size="1">
<h2>User List</h2>
 <table cellSpacing="0" cellPadding="3" border="0">
<tr><td class="report">Command</td>
<td class="report">User Name</td>
<td class="report">Full Name</td>
<td class="report">Home dir</td>
</tr>
<?php
	$u = new users();
	$usernames = $u->keys();
	foreach ($usernames as $username)
	{
		$u->read($username);
		echo '<tr><td align="right">';
		if ($u->username != "root")
		{
			echo '<a href="admin_users.php?command=areyousure&username=' . $u->username .  '">delete</a> ';
			echo '&nbsp;-&nbsp;';
		}
		
		echo '<a href="admin_users.php?command=edit&username=' . $u->username .  '">edit</a> ';
		echo '</td>';
		echo '<td>' . $u->username . '</td>';
		echo '<td>' . $u->fullname . '</td>';
		echo '<td>' . $u->home . '</td>';
		echo '</tr>';
	}
?>
 </table>

<?php
require_once ("footer.php");
//////////////////////////////////////////////////////////////////////////////
// End default HTML page
//////////////////////////////////////////////////////////////////////////////
function add ()
{
	global $CONFIG;
	session_start();
	$u = new users();
	if ( $u->exists($_REQUEST['username']))
	{
		$_SESSION['title'] = "Cannot Create User";
		$_SESSION['message'] = "The username already exists.";
		header("Location: admin_error.php");
		return;
	}
	if ( strlen($_REQUEST['username']) <= 0 )
	{
		$_SESSION['title'] = "Cannot Create User";
		$_SESSION['message'] = "The username field was blank.";
		header("Location: admin_error.php");
		return;
	}
	if ( strlen($_REQUEST['username']) > 20 )
	{
		$_SESSION['title'] = "Cannot Create User";
		$_SESSION['message'] = "The username must be less than 21 characters.";
		header("Location: admin_error.php");
		return;
	}
	if ( $_REQUEST['username'] != ereg_replace("[^A-Za-z0-9]", "", $_REQUEST['username']))
	{
		$_SESSION['title'] = "Cannot Create User";
		$_SESSION['message'] = "Invalid username. The username can only contain letters and numbers.";
		header("Location: admin_error.php");
		return;
	}
	if ( strlen($_REQUEST['password']) <= 0 )
	{
		$_SESSION['title'] = "Cannot Create User";
		$_SESSION['message'] = "The password field was blank.";
		header("Location: admin_error.php");
		return;
	}
	if ( $_REQUEST['password'] != $_REQUEST['password_confirm'] )
	{
		$_SESSION['title'] = "Cannot Create User";
		$_SESSION['message'] = "The password does not match the confirmation password.";
		header("Location: admin_error.php");
		return;
	}
        $return_page = $_SESSION['return_page'];
	header("Location: $return_page");
	$homedir = $CONFIG['upload_home'] . "/" . $_REQUEST['username'] ;
	$u = new users();
	$result = $u->create ($_REQUEST['username'], $_REQUEST['fullname'], $_REQUEST['password'], $homedir);
	mkdir($homedir, 0770);
}

function del ()
{
	session_start();
    $return_page = $_SESSION['return_page'];
	header("Location: $return_page");
	$username = $_REQUEST['username'];
	$u = new users();
	$u->read ($username);
	$result = $u->delete ();
}

function areyousure ()
{
	require_once ("header.php");
?>
<h1>Are you sure?</h1>
<hr noshade size="1">
<h2><?php echo $_REQUEST['message']; ?></h2>
 <table cellSpacing="0" cellPadding="3" border="0">
   <tr>
    <td align="right"><form name="areyousure" method="post" action="admin_users.php"><input type="hidden" name="username" value="<?php echo $_REQUEST['username']; ?>"><input type="hidden" name="command" value="del"><input type="submit" name="submit" value="YES"></form></td>
    <td align="right"><form name="areyousure2" method="post" action="admin_users.php"><input type="hidden" name="command" value="no"><input type="submit" name="submit" value="NO"></form></td>
   </tr>
 </table>
<?php
	require_once ("footer.php");
}

function update ()
{
	session_start();
    $return_page = $_SESSION['return_page'];
	if ( strlen($_REQUEST['username']) <= 0 )
	{
		$_SESSION['title'] = "Cannot Update User";
		$_SESSION['message'] = "The username field was blank.";
		header("Location: admin_error.php");
		return;
	}
	if ( strlen($_REQUEST['password']) <= 0 )
	{
		$_SESSION['title'] = "Cannot Update User";
		$_SESSION['message'] = "The password field was blank.";
		header("Location: admin_error.php");
		return;
	}
	if ( $_REQUEST['password'] != $_REQUEST['password_confirm'] )
	{
		$_SESSION['title'] = "Cannot Update User";
		$_SESSION['message'] = "The password does not match the confirmation password.";
		header("Location: admin_error.php");
		return;
	}
	$username = $_REQUEST['username'];
	$u = new users();
	if ( ! $u->read ($username)) // No username found...
	{
		$_SESSION['title'] = "Cannot Update User";
		$_SESSION['message'] = "The user was not found in the database.";
		header("Location: admin_error.php");
		return;
	}
	header("Location: $return_page");
	if ( strlen($_REQUEST['password']) > 0 )
	{
		$u->set_password ($_REQUEST['password']);
	}
	$u->fullname = $_REQUEST['fullname'];
	$u->update ();
}

function edit ()
{
	session_start();
	$self = $_SERVER['PHP_SELF'];
	$_SESSION['return_page']=$self;
	require_once ("header.php");
	$return_page = $_SESSION['return_page'];
	$username = $_REQUEST['username'];
	$u = new users();

	if ( ! $u->exists($username))
	{
		echo "Cannot find this user.";
	}
	else
	{
		$u->read ($username);
?>
<h1>Edit User Info</h1>
<hr noshade size="1">
<form name="admin_edit" method="post" action="admin_users.php">
<input type="hidden" name="command" value="update">
 <table cellSpacing="0" cellPadding="3" border="0">
   <tr>
    <td width="120">Username</td>
	<input type="hidden" name="username" value="<?php echo $u->username; ?>">
    <td> <?php echo $u->username; ?> </td>
   </tr>
   <tr>
    <td>Full Name</td>
    <td><input type="text" size="40" name="fullname" value="<?php echo $u->fullname; ?>"></td>
   </tr>
   <tr>
    <td>Password</td>
    <td><input type="password" name="password"></td>
   </tr>
   <tr>
    <td>Password Confirm</td>
    <td><input type="password" name="password_confirm"></td>
   </tr>
   <tr>
    <td></td>
    <td align="right"><input type="submit" name="submit" value="update"></td>
   </tr>
 </table>
<?php
	}

	require('return.php');
	require('footer.php');
}

?>
