<?php
// $Author: noah $
// $Revision: 0.0 $
// $Date: 2004/10/23 23:42:33 $
//
// This sets up the initial conf files.
//

require_once ("login.php");
//bounce_not_root ();

$_SESSION['return_page'] = "index.php";

require_once ("common.php");
require_once ("edit.php"); // This does the work of reading/writing config files.

if ( file_exists("../conf/config.conf") || file_exists("../conf/users.conf") )
{
    $_SESSION['title'] = "Configuration error";
    $_SESSION['message'] = "Config directory is not empty.";
    $_SESSION['message'] .= "<br>In order to initialize the config directory it is required";
    $_SESSION['message'] .= "<br>that both users.conf and config.conf be deleted.";
    $_SESSION['message'] .= "<br>Manually delete these files from the Upload Tool's config directory.";
    $_SESSION['return_page'] = "initialize.php";
    header ("Location: admin_error.php");
    return;
}

switch ($_REQUEST['command'])
{
    case 'init':
    init();
    return;
    break;
}

chdir ('../pub'); // TODO This assumes that pub exists. That is bad.
$default_home = getcwd();
require_once ("header.php");
?>
<h1>Initialize Config file and User Database</h1>
This appears to be a new installation of the Upload Tool.<br>
This form will initialize two critical files: config.conf and users.conf.
<hr noshade size="1">
<h2>Define Root User</h2>
<form name="initialize" method="post">
 <input type="hidden" name="command" value="init">
 <table cellSpacing="0" cellPadding="3" border="0">
   <tr>
    <td width="120">password</td>
    <td><input type="password" name="password"></td>
   </tr>
   <tr>
    <td width="120">password confirm</td>
    <td><input type="password" name="password_confirm"></td>
   </tr>
   <tr>
    <td width="120">home directory</td>
    <td><input type="text" size="50" name="upload_home" value="<?php echo $default_home;?>"></td>
   </tr>
   <tr>
    <td></td>
    <td align="right"><input type="submit" name="submit" value="initialize"></td>
   </tr>
 </table>
</form>
<?php
require_once ("footer.php");
//////////////////////////////////////////////////////////////////////////////
// End default HTML page
//////////////////////////////////////////////////////////////////////////////
function init ()
{
    session_start();

    // Create the config.conf file and initialize it.
    chdir ('../conf');
    $conf_dir = getcwd();
    $config_filename = $conf_dir . "/config.conf";
    if ( file_exists($config_filename) )
    {
        $_SESSION['title'] = "Configuration error";
        $_SESSION['message'] = "Config directory is corrupt. It contains no users.conf, but it has a config.conf file.";
        $_SESSION['message'] .= "<br>In order to initialize the config directory it is required that both users.conf and config.conf be deleted.";
        $_SESSION['message'] .= "<br>Manually delete these files from the Upload Tool's config directory.";
        $_SESSION['return_page'] = "initialize.php";
        header ("Location: admin_error.php");
        return;
    }

    if ( strlen($_REQUEST['password']) <= 0 )
    {
        $_SESSION['title'] = "Cannot Initialize Root";
        $_SESSION['message'] = "The password field was blank.";
        header("Location: admin_error.php");
        return;
    }
    if ( $_REQUEST['password'] != $_REQUEST['password_confirm'] )
    {
        $_SESSION['title'] = "Cannot Initialize Root";
        $_SESSION['message'] = "The password does not match the confirmation password.";
        header("Location: admin_error.php");
        return;
    }

    // initialize config.conf
    $CONFIG['upload_home'] = $_REQUEST['upload_home'];
    $e = new edit ();
    $e->set_array ($CONFIG);
    $e->save ($config_filename);
    // initialize users.conf
    $u = new users();
    $u->init("root", "Administrative Root", $CONFIG['upload_home'], $_REQUEST['password']);
    $return_page = $_SESSION['return_page'];
    header("Location: $return_page");
}
