<?php
// This script is heavily overloaded (on purpose):
//     It handles the users database (see 'users' class).
//     It displays a login prompt.
//     It handles authentication and authorization.
// So it does a lot of different things depending on what you need it to do.
// The advantage to this is that this single script can be dropped
// into a project to add all these feature with very little effort.
//
// After a successful login authentication the user is forwarded to either
// main_root.php or main_user.php.
//
// TODO the prompt() login_failed() functions should really use a template.
// Currently header.php and footer.php are included to allow some limited
// custom styling.
// $Author: noah $
// $Revision: 0.0 $
// $Date: 2004/10/23 23:42:33 $

session_start();

//////////////////////////////////////////////////////////////////////////////
// If this script is called directly without a command ($_REQUEST['command'])
// then we display the default login prompt. This makes it safe to
// include this script on other scripts, so we import the useful functions
// of this script without displaying the login prompt page.
// In other words, if you import this script then it will not call prompt().
if (basename ($_SERVER['PHP_SELF']) == basename (__FILE__))
{
    if ( ! file_exists("../conf/config.conf") || ! file_exists("../conf/users.conf") )
    {
        header ("Location: initialize.php");
        return;
    }

    if ( ! isset($_REQUEST['command']))
    {
        prompt ();
        return;
    }

    switch ($_REQUEST['command'])
    {
        case 'prompt':
        prompt ();
        return;
        break;

        case 'login_authenticate':
        sleep (3); // helps limit brute-force attacks
        login_authenticate ();
        return;
        break;

        case 'logout':
        logout ();
        return;
        break;

        case 'login_failed':
        sleep (3); // helps limit brute-force attacks
        login_failed ();
        return;
        break;
    }

}

//////////////////////////////////////////////////////////////////////////////

function prompt ()
{
    $_SESSION = array();
    session_destroy();
    header("Cache-Control: no-cache, must-revalidate");
    header("Pragma: no-cache");
    header("Expires: Mon,26 Jul 1997 05:00:00 GMT");
    require_once ("header.php");
    ?>

    <h1>Login</h1>
    <hr noshade size="1">
    <form onload="getfocus()" method="POST" action="<?php echo $_SERVER['PHP_SELF']; ?>">
    <input type="hidden" name="return_page" value="<?php echo $return_page; ?>">
    <input type="hidden" name="command" value="login_authenticate">
    <table cellSpacing="0" cellPadding="3" border="0">
    <tr>
    <td width="120">Username:</td>
    <td><input type="text" name="username" size="20" id="username"></td>
    </tr>
    <tr>
    <td width="120">Password:</td>
    <td><input type="password" name="password" size="20"></td>
    </tr>
    <tr>
    <td></td>
    <td align="right"><input type="submit" name="submit" value="login"></td>
    </tr>
    </table>
    </form>

    <?php
    require_once ("footer.php");
    return;
}

function login_failed ()
{
    require_once ("header.php");
    echo "<h2>Login Failed</h2>";
    $return_page = "login.php";
    require_once ("return.php");
    require_once ("footer.php");
}

function logout ()
{
    $_SESSION = array();
    session_destroy();
    header( "Location: login.php" );
}

function login_authenticate ()
{
    session_start();
    $_SESSION = array();
    $user_db = new users();
    if ($user_db->authenticate ($_POST['username'],$_POST['password']) == true)
    {
        $_SESSION['username'] = $_POST['username'];
        if ($_SESSION['username'] == 'root')
            header ("Location: main_root.php");
        else
            header ("Location: main_user.php");
    }
    else
    {
        header ("Location: login.php?command=login_failed");
    }
}

function bounce_not_user ()
// Call this to the top of any script to bounce out users that
// don't have a session or don't have a valid username.
// This helps prevent people from calling
// a script directly without a login.
// Note this does not attempt to prevent clever forged sessions.
{
    session_start();
    $user_db = new users();
    if ( isset($_SESSION['username']) && $user_db->exists($_SESSION['username']) )
        return; // user looks good so do not bounce.

    $_SESSION = array();
    session_destroy();
    header( "Location: login.php" );
    die;
}

function bounce_not_root ()
// Call this to the top of any script to bounce out users that
// don't have a root session. This helps prevent people from calling
// a script directly without a valid login. This makes sure that
// the user's name is "root".
// Note this does not attempt to prevent clever forged sessions.
{
    session_start();
    if ($_SESSION['username'] == "root")
        return;
    $_SESSION = array();
    session_destroy();
    header( "Location: login.php" );
    die;
}

class users
// This represents users in a database (simply a plain text file).
// Think something like the gecos fields in /etc/passwd.
{
    var $filename = "../conf/users.conf";
    var $database;
    var $username;
    var $fullname;
    var $salt;
    var $password;
    var $home;

    function dlock($filename, $staleAge = 5)
    // This is a trivial advisory lock used to control
    // simultaneous access to the password database.
    // A directory is created to signal that a file is busy.
    // If the file is already busy then this retries
    // until it is free.
    {
        ignore_user_abort(1);
        $lockDir = $filename . '.lock';
        if (is_dir($lockDir)) 
        {
            if ((time() - filemtime($lockDir)) > $staleAge) 
            {
                @rmdir($lockDir);
            }
        }

        $locked = @mkdir($lockDir);
        if ($locked === false) 
        {
            sleep (1);
            $locked = @mkdir($lockDir);
        }

        ignore_user_abort(0);
        return $locked;
    }

    function dunlock ($filename)
    {
        $lockDir = $filename . '.lock';
        rmdir ($lockDir);
    }

    function load_database ()
    // This loads the user database.
    {
        if ( ! file_exists($this->filename) )
        {
            $_SESSION['title'] = "Configuration error";
            $_SESSION['message'] = "Missing file: " . $this->filename;
            $_SESSION['message'] .= "<br>Probably the user database needs to be initialized.";
            $_SESSION['return_page'] = "initialize.php";
            header ("Location: admin_error.php");
        }

        if ( ! $this->dlock ($this->filename) )
            return False;
            
        $this->database = array();
        
        $handle = fopen ($this->filename, "rb");
        while ($data = fgetcsv($handle, 10000))
        {
            $key = array_shift ($data);
            $this->database[$key] = $data;
        }
        fclose ($handle);
 
        $this->dunlock ($this->filename);
        return True;
    }

    function csv_quote ($s)
    // This quotes a string for output to a CSV file.
    {
        $s = str_replace('"', '""', $s);
        if ($s{0} == '"')
        {
            $s = '""' . $s;
        }
        if ($s{strlen($s)-1} == '"')
        {
            $s = '"' . $s;
        }
        return $s;
    }

    function save_database ()
    {
        if ( ! $this->dlock ($this->filename) )
            return False;

        $handle = fopen ($this->filename, "wb");
        foreach ($this->database as $key => $row)
        {
            fwrite ($handle, '"' . $this->csv_quote($key) . '"');
            fwrite ($handle, ",");
            foreach ($row as $field)
            {
                fwrite ($handle, '"' . $this->csv_quote($field) . '"');
                fwrite ($handle, ",");
            }
            fwrite ($handle, "\n");
        }
        fclose($handle);
        $this->dunlock ($this->filename);
    }

    function users ()
    {
        $this->username = "";
        $this->fullname = "";
        $this->salt = "";
        $this->password = "";
        $this->home = "";
    }

    function create ($new_username, $new_fullname, $new_password, $new_home)
    {
        $this->load_database();
        $this->username = $new_username;
        $this->fullname = $new_fullname;
        $this->set_password ($new_password);
        $this->home = $new_home;
        $this->update();
    }

    function set_password ($new_password)
    {
        $this->salt = $this->random_salt();
        $this->password = $this->password_encrypt($this->salt, $new_password);
    }

    function read ($username)
    {
        $this->load_database();
        if ( ! isset($this->database[$username] ))
            return false;

        $data = $this->database[$username];
        $this->username = $username;
        $this->fullname = $data[0];
        $this->home = $data[1];
        $this->salt = $data[2];
        $this->password = $data[3];
    
        return true;
    }

    function update ()
    {
        $this->load_database();
        $this->database[$this->username]=array($this->fullname,$this->home,$this->salt,$this->password);
        $this->save_database();
    }

    function init ($username, $fullname, $home, $password)
    // This initialized the user database, but ONLY if the file does not exist.
    {
        if ( file_exists($this->filename) )
            return False;
        $this->database = array();
        $this->set_password ($password);
        $this->database[$username]=array($fullname,$home,$this->salt,$this->password);
        $this->save_database();
        return True;
    }

    function delete ()
    {
        $this->load_database();
        unset($this->database[$this->username]);
        $this->save_database();
    }

    function exists ($username)
    {
        $this->load_database();
        if (isset ($this->database[$username]))
        {
            return true;
        }
        return false;
    }

    function keys ()
    {
        $this->load_database();
        return array_keys($this->database);
    }

    function authenticate ($username, $cleartext_password)
    {
        $this->read($username);
        if ($this->read ($username) == false)
        {
            return false;
        }

        $hashed_password = $this->password_encrypt($this->salt, $cleartext_password);
        if (strcasecmp ($this->password, $hashed_password) == 0)
        {
            return true;
        }
        return false;
    }

    function password_encrypt ($salt, $cleartext_password)
    {
        return md5 ($salt . $cleartext_password);
    }

    function random_salt ($length=6)
    // This returns a random string useful for salting passwords hashes.
    {
        $s='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_@';
        $array_length = strlen ($s);
        $salt = "";
        for ($i=0; $i<$length; ++$i)
        {
            $salt=$salt . $s{rand(0,$array_length)};
        }
        return $salt;
    }
} // End class users

?>
